package com.kingdee.eas.custom.bill.salary;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.dao.IObjectPK;
import java.lang.String;
import com.kingdee.eas.custom.bill.salary.app.*;
import com.kingdee.bos.framework.*;
import com.kingdee.bos.Context;
import com.kingdee.eas.framework.ICoreBillEntryBase;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.CoreBillEntryBase;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.bos.util.*;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;

public class PayPacketEntry extends CoreBillEntryBase implements IPayPacketEntry
{
    public PayPacketEntry()
    {
        super();
        registerInterface(IPayPacketEntry.class, this);
    }
    public PayPacketEntry(Context ctx)
    {
        super(ctx);
        registerInterface(IPayPacketEntry.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("C7B84004");
    }
    private PayPacketEntryController getController() throws BOSException
    {
        return (PayPacketEntryController)getBizController();
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@return
     */
    public PayPacketEntryInfo getPayPacketEntryInfo(IObjectPK pk) throws BOSException, EASBizException
    {
        try {
            return getController().getPayPacketEntryInfo(getContext(), pk);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@param selector ȡֵ
     *@return
     */
    public PayPacketEntryInfo getPayPacketEntryInfo(IObjectPK pk, SelectorItemCollection selector) throws BOSException, EASBizException
    {
        try {
            return getController().getPayPacketEntryInfo(getContext(), pk, selector);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param oql ȡֵ
     *@return
     */
    public PayPacketEntryInfo getPayPacketEntryInfo(String oql) throws BOSException, EASBizException
    {
        try {
            return getController().getPayPacketEntryInfo(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@return
     */
    public PayPacketEntryCollection getPayPacketEntryCollection() throws BOSException
    {
        try {
            return getController().getPayPacketEntryCollection(getContext());
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param view ȡ
     *@return
     */
    public PayPacketEntryCollection getPayPacketEntryCollection(EntityViewInfo view) throws BOSException
    {
        try {
            return getController().getPayPacketEntryCollection(getContext(), view);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param oql ȡ
     *@return
     */
    public PayPacketEntryCollection getPayPacketEntryCollection(String oql) throws BOSException
    {
        try {
            return getController().getPayPacketEntryCollection(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}